<?php
require_once 'XML/RPC.php';
class XMLRPCModel{
	function __construct(){
	}
    //only one function is required since both get and set types of functionallity
    //are exactly the same.
	function sendMessage($messageString, $URL, $serverPage, $portNum, $parameters){
        //create an XML_RPC_Message to be sent to the XML_RPC_Server//prepare all of the parameters to be sent
        //Since we are communicating with a PHP base server on the other end we will treat 
        //all of the parameters as strings.  If it was not PHP then the parameter types would be
        //required and would need to be passed in with the parameter array values
        $parameterValueArray = null;
        if($parameters != null){
            $parameterValueArray = array();
            $numParameters = sizeof($parameters);
            for($i = 0; $i < $numParameters; $i++){
                $parameterValueArray[] = new XML_RPC_Value($parameters[$i], "string");
            }
        }
        $msg = new XML_RPC_Message($messageString, $parameterValueArray);
        //create an XML_RPC_Client to handle all of the communication with the server
        $client = new XML_RPC_Client($serverPage, $URL, $portNum);
        //send off the message and get back the data served up by the service.
        //This is a synchronous call.
        $rpcData = $client->send($msg);
        //if there was no error return the XML_RPC_Response for processing
        //rpcData will be null if a faulty messageString was passed in
        if($rpcData != null && !$rpcData->faultCode()){
            return $rpcData;
        }
        return null;
	}
}
?>