var theController = new Controller();//initialize the controller;
function init(){
	//initialize the page to make sure that the display is blank
	document.getElementById('content').innerHTML='';
    loadFirstSubPage();
}

function Controller(){//the constructor
	//a map of approved commands
	this.acceptableCommands = {pat:'getPatients', nur:'getNurses',doct:'getDoctors', pat_vis:'getPatientVisits', vis:'getVisits', ret_pat_nur:'getPatientNurseAssign',
       update_pat_nur: 'updatePatientNurseAssign', cur_inv:'getInventory', sup_inv:'getSupplierInventory', cur_inv_cost:'getInventoryChart',
       login:'login', store:'storeSession', home:'goToHome', storeHome:'storeSession', showMashup:'mashup',
       cr_rep:'getReportCreation', vw_all_rep:'getReportList', pv_rep:'getReportPreview', snd_rep:'storeReportDef',
clr_rep:'resetReportDef', vw_rep:'getReport', rm_rep:'removeReportDef'};
	//the dispatch method is used to handle all requests
	this.dispatch = function(cmd, event){
        if(event == null){
            event = window.event;
        }
        //call the method to stop the default behavior of the event
        stopDefault(event);
        //if the user is not logged in and is not currently trying to login
        //display the login screen.
        if(!session.getAttribute('loggedIn') && cmd !='login'){
            var loginDisp = new showLoginVCO();
            loginDisp.notify(cmd);
        }
        //the user is logged in and needs access to data
        else{
            //see if the command is valid
            var cmdName = this.acceptableCommands[cmd];
            if(cmdName != null){
                var objName = cmdName+'BCO';
                //get the target element of the event
                var target = null;//a change made to support history tracking
                if(event != null){
                    target = event.currentTarget || event.srcElement;//others or IE
                }
                //use reflection to instantiate the appropriate control object
                new window[objName](target);
            }
       }
	}
}

//stop an event from doing its' default behavior since it will be handled in the BCO and VCO
function stopDefault(event){
    if(event){
        if (event.preventDefault)// non-IE
                event.preventDefault();
        event.returnValue = false;// IE
    }
}
//remove white space from the beginning and end of a string
function trim(aString){
    return aString.replace(/^\s+|\s+$/g, '');
}
//check for a login cookie for safari
function checkLoginCookie(){
	var cookies = document.cookie.split(';');
    var numCookies = cookies.length;
	for(var i=0;i < numCookies;i++) {
		var aCookie = trim(cookies[i]);
		if (aCookie.indexOf('med_login') == 0){
                return true;
        }
	}
    return false;
}