<?php
class Controller{
	private $acceptableCommands;
    //Controller constructor
	function __construct(){
        //set up the map values
		$this->acceptableCommands = array("pat"=>"Patient", "nur"=>"Nurse", "pat_vis"=>"PatientVisit", 
        "ret_pat_nurse"=>"RetrievePatNurse", "update_pat_nur"=>"UpdatePatNurse", "noCmd"=>"NoCmd", 
        "sup_inv"=>"SupplierInventoryListing", "cur_inv"=>"LocalInventoryListing",
        "inv_cost"=>"LocalInventoryCost","login"=>"Login","store"=>"StoreSession",
        "crRepDef"=>"CreateReportDef","delRepDef"=>"DeleteReportDef","strRepDef"=>"StoreReportDef",
        "viewAllRepDef"=>"ViewAllReportDefs","viewRepDef"=>"ViewReportDef", "prevRep"=>"PreviewReport",
        "rmvRepDef"=>"RemoveReportDef", "doct"=>"Doctor");
	}
	function dispatch($cmd, $type, $data)
	{
		$functionName = "BadCommand".$type;
        if($this->acceptableCommands[$cmd]){
            $functionName = $this->acceptableCommands[$cmd].$type;
        }
        //include the file containing the BCO or VCO needed.
        require_once getcwd().DIRECTORY_SEPARATOR.$functionName.".inc";
        //instantiate the control object
        $aControlObject = new $functionName($data);
        $returnedData = $aControlObject->execute();
        return $returnedData;
	}
}
?>
