<?php
//used by the XML_RPC_Server to serve up database information as XML to the client.
class ExposedInventoryListingVCO{
	function __construct($data){
		$this->data = $data;
	}
	function execute(){
        //create an array to hold both the headers and the records.
        $values = array();
        //create an array to hold the header information
        $headers = array();
        
        $numRecords = -1;
        foreach ($this->data as $fieldName => $field) {
            //create an XML_RPC_Value object to hold each header as a string
            $aHeader = new XML_RPC_Value($fieldName, "string");
            //add each header to the headers array
            $headers[] = $aHeader;
			if($numRecords == -1){
				$numRecords = sizeof($field);
			}
		}
        //place the headers in the values array as an array type
        $values[] = new XML_RPC_Value($headers, "array");
        //create an array to hold all of the records as XML_RPC_Value objects
		$records = array();
		for ($i = 0; $i < $numRecords; $i++) {
			$aRecord = array();
			foreach ($this->data as $field) {
                //store each field as type string since it doesn't really matter to the PHP
                //on the other end.
                $aValue = new XML_RPC_Value($field[$i], "string");
				$aRecord[] = $aValue;
			}
            //store each record as an XML_RPC_Value of type array
            $aRecordVal = new XML_RPC_Value($aRecord, "array");
            //add each record to the records array
			$records[] = $aRecordVal;
		}
        //place the records in the values array as an array type
        $values[] = new XML_RPC_Value($records, "array");
        //create an XML_RPC_Response for the client using an XML_RPC_Value to hold the values array
        $returnValue = new XML_RPC_Response(new XML_RPC_Value($values, "array"));
        //return the response so that the calling function can return it to the server for sending.
        return $returnValue;
	}
}
?>