<?php
class LocalInventoryCostBCO{
	function __construct($data){
		$this->data = $data;
	}
	function execute(){
        //include and use the BCO used to retreive the data
		require_once getcwd().'\localInventoryListingBCO.inc';//get the file containing the database model object
        $aListBCO = new LocalInventoryListingBCO($this->data);
        $results = $aListBCO->execute();
        //setup the arrays to hold the data to be passed for use by the VCO
        $costArray = array();//containing array
        $costArray[] = array();//the array of item names
        $costArray[] = array();//the array of total cost for the items
        //retrieve each of the appropriate columns from the Oracle result set
        $descriptionArray = $results["ITEM_DESCRIPTION"];
        $priceArray = $results["ITEM_PRICE"];
        $pricePerArray = $results["ITEM_PRICE_PER"];
        $numInvArray = $results["ITEM_STOCK"]; 
        //calculate the cost of stock for each item.
        $numValues = sizeof($priceArray);
        for($i = 0; $i < $numValues; $i++){
            $aPrice = $priceArray[$i];//the cost of a group
            $aPricePer = $pricePerArray[$i];//the size of a group
            $aNumInv = $numInvArray[$i];//the number in inventory
            //remove all charaters that are not numeric
            $aPricePer = trim(ereg_replace('[a-zA-Z]','',$aPricePer));//replace all letters and remove all beginning and ending white space
            //if there is nothing left in the string then assume the price is per unit described in the table
            if(strlen($aPricePer) == 0){
                $aPricePer = 1;
            }
            $itemInventoryCost = $aPrice*$aNumInv/$aPricePer;//calculate the price per unit
            $costArray[0][] = $descriptionArray[$i];//set the name of the item
            $costArray[1][] = $itemInventoryCost;//set the total cost of the items by that name
        }
        return $costArray;//return the cost array for processing by the VCO
    }
}
?>