<?php
class PreviewReportBCO{
	function __construct($data){
		$this->data = $data;
	}
	function execute(){
       if(!$_REQUEST['patient'] || !$_REQUEST['stats'] || !$_REQUEST['from'] || !$_REQUEST['to']){
            return null;
        }
        $aPatientID = $_REQUEST['patient'];
        $aStatisticsList = addslashes($_REQUEST['stats']);
        $aFromDate = $_REQUEST['from'];
        $aToDate = $_REQUEST['to'];
        //prepare the binding array
        $fieldArray = array(array(":aPatientID", $aPatientID, SQLT_CHR),
                        array(":aFromDate", $aFromDate, SQLT_CHR),
                        array(":aToDate", $aToDate, SQLT_CHR));
        //start the query string                
        $aSQLString = "SELECT ";
        //get the statistics as an array
        $aStatsArray = explode( ";", $aStatisticsList);
        $numStats = sizeof($aStatsArray);
        //insert a binding statement array for each statistic
        for($i = 0; $i < $numStats; $i++){
            $aStat = $aStatsArray[$i];
            //if the stat name ends with _DATE change the formatting of the result
            //of the query.
            if(substr($aStat, strlen($aStat) - strlen("_DATE")) == "_DATE"){
                $aStat = "to_char(".$aStat.",'DD-MM-YYYY') as ".$aStat;
            }
            $aSQLString .= $aStat;
            if($i < $numStats - 1){
                $aSQLString .=",";
            }
        }
        //complete the query string
        $aSQLString .= " FROM visit WHERE patient_id = :aPatientID AND visit_date BETWEEN to_date(:aFromDate,'dd mm yyyy') AND to_date(:aToDate,'dd mm yyyy')";
        $aSQLString .= " ORDER BY VISIT_DATE";
        error_log($aSQLString);
        require_once getcwd().DIRECTORY_SEPARATOR.'DBModel.inc';//get the file containing the database model object
		$model = new DBModel();
        //retreive the report preview data
		return $model->getData($aSQLString, $fieldArray);
    }
}