/*
 * This library depends on the drag and drop
 * library found in the util.js file.
 */

mashFrame.mashCount = 0;
mashFrame.mashArray = new Array();

function mashFrame(aURL, parentID, xLoc, yLoc, width, height, scrollDown, scrollRight){
    mashFrame.mashArray[mashFrame.mashCount] = this;
    mashFrame.mashCount++;
    
    var parent = document.getElementById(parentID);
    if(aURL.indexOf('http:') != 0){
        aURL = 'http://'+aURL;
    }
    var mashFrameName = 'mashFrame'+mashFrame.mashCount;
    //create the elements required for display
    this.iframe = document.createElement('iframe');
    this.iframe.id = this.iframe.name = mashFrameName;
    
    this.resizableContainer = document.createElement('div');
    this.movableContentContainer = document.createElement('div');
    this.topMoveDiv = document.createElement('div');
    this.rightResizeDiv = document.createElement('div');
    this.leftResizeDiv = document.createElement('div');
    this.bottomResizeDiv = document.createElement('div');
    //setup the iframe
    this.iframe.src = aURL;
    this.iframe.style.width = '1000px';
    this.iframe.style.height = '5000px';
    this.iframe.style.position = 'relative';
    this.iframe.style.top = '0px';
    this.iframe.style.left = '10px';
    
    this.resizableContainer.className = 'resizableContainer';
    this.resizableContainer.style.zIndex = this.resizableContainer.style.zIndex*1 + mashFrame.mashCount*1 + 49;
    
    //set the defined location and size
    this.origXLoc = xLoc || 0;
    this.resizableContainer.style.left = this.origXLoc;
    
    this.origYLoc = yLoc || 0;
    this.resizableContainer.style.top = this.origYLoc;
    
    this.origWidth = width || 300;
    this.curWidth = this.width = this.origWidth;
    this.resizableContainer.style.width = this.origWidth+'px';
    
    this.origHeight = height || 294;
    this.curHeight = this.height = this.origHeight;
    this.resizableContainer.style.height = this.origHeight+'px';
    
    this.origScrollDown = -(scrollDown || 0);
    
    this.origScrollRight = -(scrollRight || 0);
    //this are only used to support the scrollbars that are required on windows
    this.scrollChangeX = 0;
    this.scrollChangeY = 0;
    
    
    //setup the dragging div
    
    this.topMoveDiv.left = 0;
    this.topMoveDiv.className = 'topMove';
    this.topMoveDiv.whenStartDragging = mashSelected;
    this.topMoveDiv.whenDropped = mashDeSelected;
    this.topMoveDiv.whenDragging = moveMash;
    this.topMoveDiv.mashFrame = this;
    this.resizableContainer.appendChild(this.topMoveDiv);
    makeDraggable(this.topMoveDiv);
     
    //setup the viewable window
    //is windows
    //the default height is 294 and width is 300
    if(navigator.platform.indexOf('Win') != -1){
        this.movableContentContainer.style.width = (this.origWidth - 20)+'px';
        this.movableContentContainer.style.height = (this.origHeight)+'px';
    }
    //not windows.  Only tested on OS X.  Linux not tested.
    else{
        this.movableContentContainer.style.width = (this.origWidth - 8)+'px';
        this.movableContentContainer.style.height = (this.origHeight - 2)+'px';
    }
    
    this.movableContentContainer.style.margin = '4px';
    this.movableContentContainer.style.marginTop = '0px';
    
    
    
    //not windows
    if(navigator.platform.indexOf('Win') != -1){
        this.movableContentContainer.style.marginLeft = '15px';
        this.resizableContainer.style.marginLeft = '0px';
        this.iframe.style.marginLeft = '-10px';
    }
    this.resizableContainer.appendChild(this.movableContentContainer);
    //insert the iframe into the viewable window
    this.movableContentContainer.appendChild(this.iframe);
    
    this.glassPane = document.createElement('div');
    this.glassPane.style.width = '2000px';
    this.glassPane.style.height = '5000px';
    this.glassPane.style.position = 'relative';
    this.glassPane.style.marginTop = '-5000px';
    
    this.movableContentContainer.appendChild(this.glassPane);
    this.glassPane.iframe = this.iframe;
    this.glassPane.ignoreScrolling = true;
    //not windows
    if(navigator.platform.indexOf('Win') == -1){
        this.glassPane.style.cursor = 'move';
        this.movableContentContainer.style.overflow = 'hidden';
        makeDraggable(this.glassPane);
    }
	//is windows
    else{
        this.movableContentContainer.style.overflow = 'auto';
		this.movableContentContainer.mashFrame = this;
		this.movableContentContainer.onscroll = function(){
			this.mashFrame.scrollChangeY = this.scrollTop;
			this.mashFrame.scrollChangeX = this.scrollLeft;
			 
		}
    }
    this.iframe.style.top = this.origScrollDown +'px';
    this.iframe.style.left = this.origScrollRight + 'px';
    
    this.glassPane.mashFrame = this;
    
    this.glassPane.whenDragging = function(){
        this.iframe.style.top = (this.top + this.mashFrame.origScrollDown)+'px';
        this.iframe.style.left = (this.left + this.mashFrame.origScrollRight) + 'px';
    };
     
    parent.appendChild(this.resizableContainer);
    
    
    this.resizableContainer.parentNode.onmousemove = function(event){
        stopStandardBehavior(event);
    }
    
   
    //setup each of the resizing divs
    
    this.leftResizeDiv.left = 0;
    this.leftResizeDiv.style.marginTop = -(this.origHeight+6);
	var shift = 4;
	if(navigator.platform.indexOf('Win') != -1){
		shift = 2;
	}
    this.leftResizeDiv.style.height = (this.origHeight + shift)+'px';
    this.leftResizeDiv.className = 'leftResize';
    this.resizableContainer.appendChild(this.leftResizeDiv);
    makeDraggable(this.leftResizeDiv);
    this.leftResizeDiv.whenStartDragging = mashSelected;
    this.leftResizeDiv.whenDropped = mashDeSelected;
    this.leftResizeDiv.mashFrame = this;
    this.leftResizeDiv.whenDragging = changeWidth;
    
        
    this.rightResizeDiv.narrowShift = 0;
    this.rightResizeDiv.style.marginTop = -(this.origHeight+15);
    this.rightResizeDiv.style.height = (this.origHeight + 21)+'px';
    this.rightResizeDiv.style.left = (this.origWidth - 4)+'px';
    this.rightResizeDiv.className = 'rightResize';
    this.resizableContainer.appendChild(this.rightResizeDiv);
    makeDraggable(this.rightResizeDiv);
    this.rightResizeDiv.whenStartDragging = mashSelected;
    this.rightResizeDiv.whenDropped = mashDeSelected;
    this.rightResizeDiv.mashFrame = this
    this.rightResizeDiv.whenDragging = changeWidth
	//if is windows
    if(navigator.platform.indexOf('Win') != -1){
		//if is IE
		if(navigator.userAgent.indexOf('MSIE') != -1){
			this.rightResizeDiv.style.marginTop = -(this.origHeight+19);
			this.rightResizeDiv.style.height = (this.origHeight + 38)+'px';
		}
		else{
			this.rightResizeDiv.style.marginTop = -(this.origHeight+15);
			this.rightResizeDiv.style.height = (this.origHeight + 30)+'px';
		}
    }
    
    this.bottomResizeDiv.className = 'bottomResize';
	shift = 11;
	var topShift = 0;
    if(navigator.platform.indexOf('Win') != -1){
		shift = 0;
		topShift = -7;
		if(navigator.userAgent.indexOf('MSIE') != -1){
			topShift = -11;
		}
	}
    this.bottomResizeDiv.style.width = (this.origWidth + shift)+'px';
    this.resizableContainer.appendChild(this.bottomResizeDiv);
    makeDraggable(this.bottomResizeDiv);
    this.bottomResizeDiv.whenStartDragging = mashSelected;
    this.bottomResizeDiv.whenDropped = mashDeSelected;
    this.bottomResizeDiv.mashFrame = this
    this.bottomResizeDiv.whenDragging = changeHeight;
	this.bottomResizeDiv.style.top = topShift + 'px';
    
}

function moveMash(event){
    this.mashFrame.resizableContainer.style.top = (this.mashFrame.origYLoc + this.top)+'px';
    this.mashFrame.resizableContainer.style.left = this.mashFrame.origXLoc + this.left+this.mashFrame.leftResizeDiv.left+'px';
    this.style.top = '0px';
    this.style.left = '0px';
}

function changeHeight(event){
	this.mashFrame.heightChanged = true;//a hack for windows Firefox and IE
    this.mashFrame.curHeight = (this.mashFrame.curHeight*1)+(this.yDiff*1);

    this.mashFrame.movableContentContainer.style.height = this.mashFrame.curHeight+'px';
    var shift = shiftTop = 0;
	var rightShiftTop = 2;
	var rightShiftHeight = 18;
    if(navigator.platform.indexOf('Win') != -1){
        shift = 0;
        shiftTop = -9;
		rightShiftTop = 2;
		rightShiftHeight = 30;
		if(navigator.userAgent.indexOf('MSIE') != -1){
			rightShiftHeight = 38;
			shiftTop = -13;
		}
    }
	this.mashFrame.rightResizeDiv.style.height = (this.mashFrame.curHeight + rightShiftHeight)+'px'
	this.mashFrame.rightResizeDiv.style.top = rightShiftTop+2*(this.mashFrame.origHeight - this.mashFrame.curHeight)+'px';
    this.mashFrame.leftResizeDiv.style.height = (this.mashFrame.curHeight+shift)+'px';
    this.mashFrame.leftResizeDiv.style.top = (this.mashFrame.origHeight - this.mashFrame.curHeight+2)+'px';
    
    this.style.top = shiftTop+2*(this.mashFrame.origHeight - this.mashFrame.curHeight+2)+'px';
    this.style.left = '0px';
}
function changeWidth(event){
	var widthShift = 0;
    if(this.className == 'leftResize'){
        this.mashFrame.curWidth = (this.mashFrame.curWidth*1)-(this.xDiff*1);
        var newLeft = this.mashFrame.origXLoc + this.left+this.mashFrame.topMoveDiv.left+'px';
        this.mashFrame.resizableContainer.style.left = newLeft;
        var shift = -4;
        if(navigator.platform.indexOf('Win') != -1){
            shift = -4;
			widthShift = -20;
        }
        this.mashFrame.rightResizeDiv.style.left = (this.mashFrame.curWidth+shift)+'px';
        //this.mashFrame.rightResizeDiv.style.left = this.mashFrame.curWidth - this.mashFrame.origWidth + 'px';
        this.mashFrame.rightResizeDiv.narrowShift -= this.xDiff;
        this.style.left = '0px';
        this.style.top = (this.mashFrame.origHeight - this.mashFrame.curHeight+2)+'px';
    }
    else{
        var shift = 5;
		//if windows
        if(navigator.platform.indexOf('Win') != -1){
            shift = 2;
			//this is a hack for Firefox and IE on windows.
			//without this and line 1 in changeHeight a 
			//2 pixel shift happens to the top of the 
			//right resize div if the mash frame 
			//has not been resized.
			if(!this.mashFrame.heightChanged){
				shift = 0;
			}
		
			widthShift = -20;
        }
        this.mashFrame.curWidth = (this.mashFrame.curWidth*1)+(this.xDiff*1);
        this.style.left = (this.left + this.narrowShift) +'px';
        this.style.top = shift+2*(this.mashFrame.origHeight - this.mashFrame.curHeight)+'px';
    }
    var shift = 11;
    if(navigator.platform.indexOf('Win') != -1){
        shift = 0;
    }
    this.mashFrame.movableContentContainer.style.width = (this.mashFrame.curWidth + widthShift) + 'px';
    this.mashFrame.topMoveDiv.style.width = this.mashFrame.bottomResizeDiv.style.width = (this.mashFrame.curWidth+shift)+'px';
}

function mashSelected(){
    this.mashFrame.parentActive = true;
    var numMash = mashFrame.mashArray.length;
    for(var i = 0; i < numMash; i++){
        if(mashFrame.mashArray[i].resizableContainer.style.zIndex >= this.mashFrame.resizableContainer.style.zIndex){
            mashFrame.mashArray[i].resizableContainer.style.zIndex = mashFrame.mashArray[i].resizableContainer.style.zIndex - 1;
        }
    }
    this.mashFrame.resizableContainer.style.zIndex = 49+mashFrame.mashCount;
}
function mashDeSelected(){
    this.mashFrame.parentActive = false;
}
function getMashupDescriptor(){
    var descriptorArray = new Array();
    var numFrames = mashFrame.mashArray.length;
    for(var i = 0; i < numFrames; i++){
        var aMashFrame = mashFrame.mashArray[i];
        var aDescriptorMap = new Object();
        aDescriptorMap.URL = aMashFrame.iframe.src;
        aDescriptorMap.top = aMashFrame.resizableContainer.style.top.split('px')[0];
        aDescriptorMap.left = aMashFrame.resizableContainer.style.left.split('px')[0];
        aDescriptorMap.width = aMashFrame.curWidth;
        aDescriptorMap.height = aMashFrame.curHeight;
        aDescriptorMap.scrollDown = aMashFrame.origScrollDown + aMashFrame.scrollChangeY;
        aDescriptorMap.scrollRight = aMashFrame.origScrollRight + aMashFrame.scrollChangeX;
        descriptorArray[i] = aDescriptorMap;
    }
    return descriptorArray;
}


function getWidth(aNode){
    return aNode.offsetWidth;
}
function getHeight(aNode){
    return aNode.offsetHeight;
}

function resetScrollBars(){
	//if is windows
	if(navigator.platform.indexOf('Win') != -1){
		for(var i = 0; i < mashFrame.mashCount; i++){
			var aMashFrame = mashFrame.mashArray[i];
			aMashFrame.movableContentContainer.scrollTop = 0;
			aMashFrame.movableContentContainer.scrollLeft = 0;
		}
	}
}

function requestNewMashFrame(aParentID){
    var aURL = prompt('Please enter the URL of the desired page');
    if(aURL){
        mashFrame(aURL, parentID);
    }
}
