<?php
class RetrievePatNurseVCO{
	function __construct($data){
		$this->data = $data;
	}
	function execute(){
        $nurseData = $this->data[0];
        //retrieve both the patient data and the nurse data
        $unassignedPatientData = $this->data[1];
        $assignedPatientData = $this->data[2];
		//generate the headers of the table from the nurse data
        $nurseFirstNameField = $nurseData["FNAME"];
        $nurseLastNameField = $nurseData["LNAME"];
        $nurseIDField = $nurseData["ID"];
        $numNurses = sizeof($nurseIDField);
        print("<table id='nursePatData'><tr>");
        print("<th>Unassigned Patients</th>");
        //map the output table column number to the nurse ids
        $nurseIDByColumnNumber = array();
        //insert the name of each nurse as a header for the table
		for ($i = 0; $i < $numNurses; $i++) {
			print("<th id='nurse_".$nurseIDField[$i]."'>".$nurseFirstNameField[$i]." ".$nurseLastNameField[$i]."</th>\n");
            //add the nurse id as the value to a numerically keyed map
            $nurseIDByColumnNumber[] = $nurseIDField[$i];
		}
		print("</tr><tr>");
        //get fields for unassigned patients
        $patientIDField = $unassignedPatientData["ID"];
        $patientFirstNameField = $unassignedPatientData["FNAME"];
        $patientLastNameField = $unassignedPatientData["LNAME"];
        //store the number of unassigned patients
        $numPatientRecords = sizeof($patientIDField);
        //create string containing a list of unassigned patients
        print("<td>\n<ul id='unassignedPatList'>\n");
        for($i = 0; $i < $numPatientRecords; $i++){
            print("<li id='".$patientIDField[$i]."'>".$patientFirstNameField[$i]." ".$patientLastNameField[$i]."</li>\n");
        }
        print("</ul>\n</td>\n");
        /*
        * Create the list items for the patients assigned to nurses
        */
        
        $patientIDField = $assignedPatientData["ID"];
        $patientFirstNameField = $assignedPatientData["FNAME"];
        $patientLastNameField = $assignedPatientData["LNAME"];
        $nurseIDField = $assignedPatientData["NURSE_ID"];
        $numPatientRecords = sizeof($patientIDField);
        //create a map of assigned nurse id to  assigned patient list map
        $patientListByNurse = array();
        for($i = 0; $i < $numPatientRecords; $i++){
            //create a list item describing the assigned patient
            $aListItem = "<li id='".$patientIDField[$i]."'>".$patientFirstNameField[$i]." ".$patientLastNameField[$i]."</li>\n";
            //append the assigned patient list item to the map with the nurse id as the key
            $patientListByNurse[$nurseIDField[$i]] .= $aListItem;
        }
        //generate the unordered lists for each nurse
        for($i = 0; $i < $numNurses; $i++){
            $nurseID = $nurseIDByColumnNumber[$i];
            //output the containing table data and the unorderd list for each nurse
            print("<td class='assignedPat'>\n<ul id='".$nurseID."' class='assignedPatList'>\n");
            if(array_key_exists($nurseID, $patientListByNurse)){
                //output the patient list items for the specified nurse
                print($patientListByNurse[$nurseID]);
            }
            print("</ul>\n</td>\n");
        }
        //complete the second table row and the table.
		print("</tr></table>");
	}
}
?>