<?php
class StoreReportDefBCO{
	function __construct($data){
		$this->data = $data;
	}
	function execute(){
       if(!$_REQUEST['patient'] || !$_REQUEST['stats'] || !$_REQUEST['from'] || !$_REQUEST['to']){
            return null;
        }
        //Generate the SQL to be stored as the report definition
        //since the SQL is to be stored binding can
        //not be done.  addslashes will secure
        //the data from SQL injection.
        $aPatientID = addslashes($_REQUEST['patient']);
        $aStatisticsList = addslashes($_REQUEST['stats']);
        $aFromDate = addslashes($_REQUEST['from']);
        $aToDate = addslashes($_REQUEST['to']);
        $aProducerID = $_SESSION['user_id'];
        //start the query string                
        $aSQLString = "SELECT ";
        //get the statistics as an array
        $aStatsArray = explode( ";", $aStatisticsList);
        $numStats = sizeof($aStatsArray);
        //insert a binding statement array for each statistic
        for($i = 0; $i < $numStats; $i++){
            $aSQLString .= $aStatsArray[$i];
            if($i < $numStats - 1){
                $aSQLString .=",";
            }
        }
        //complete the query string
        $aSQLString .= " FROM visit WHERE patient_id = ".$aPatientID." AND visit_date BETWEEN to_date('".$aFromDate."','dd-mm-yyyy') AND to_date('".$aToDate."','dd-mm-yyyy')";
        $aSQLString .= " ORDER BY VISIT_DATE";
        
        
       if(!$_REQUEST['recip']){
            return null;
        }
        //for each recipient store the report definition
        //this should be made more efficient by storing the definition once
        //and then using a foreign key to reference it
        //but this is sufficient and will make deletion simpler
        $aRecipientID = $_REQUEST['recip'];
        $queryString = "";
        $fieldArray = null;
        $ID = $_REQUEST['reportID'];
        //if no report id is sent then store the report as a new report
        if(!$ID){
            //create a unique record ID for the entry that can be
            //easily returned to the client
            $ID = $_SERVER['REMOTE_ADDR'].microtime();
            //create a 2 dimensional array, an array of arrays, containing each of the keys, values, and types
            $fieldArray = array(array(":aPatientID", $aPatientID, SQLT_CHR)
                                ,array(":aProducerID", $aProducerID, SQLT_CHR)
                                ,array(":aRecipientID", $aRecipientID, SQLT_CHR)
                                ,array(":aReportDefinition", $aSQLString, SQLT_CHR));
            
            $queryString = "INSERT INTO report_definitions VALUES('".$ID."', :aRecipientID, :aProducerID, :aPatientID, :aReportDefinition, SYSDATE, null, 1)";
            
        }
        //if a report id is sent then update the report
        else{
            $fieldArray = array(array(":aReportDefID", $ID, SQLT_CHR));
            $queryString = "UPDATE report_definitions SET report_definition = '".$aSQLString."' WHERE report_id = :aReportDefID";
        }
        error_log("storing report def using: ".$queryString);
        //get the file containing the database model object
        require_once getcwd().DIRECTORY_SEPARATOR.'DBModel.inc';
		$model = new DBModel();
        $localData = $model->setData($queryString, $fieldArray);
        return $ID;
	}
}
?>